std::__atomic_base< _ITp > Struct Template Reference
Atomics

`#include <atomic_base.h>`

## Public Types

using | difference_type = value_type
using | value_type = _ITp

## Public Member Functions

constexpr | __atomic_base (__int_type __i) noexcept
| __atomic_base (const __atomic_base &)=delete
| __attribute__ ((__always_inline__)) void store(__int_type __i
bool | is_lock_free () const noexcept
bool | is_lock_free () const volatile noexcept
| operator __int_type () const noexcept
| operator __int_type () const volatile noexcept
__int_type | operator&= (__int_type __i) noexcept
__int_type | operator&= (__int_type __i) volatile noexcept
__int_type | operator++ () noexcept
__int_type | operator++ () volatile noexcept
__int_type | operator++ (int) noexcept
__int_type | operator++ (int) volatile noexcept
__int_type | operator+= (__int_type __i) noexcept
__int_type | operator+= (__int_type __i) volatile noexcept
__int_type | operator-- () noexcept
__int_type | operator-- () volatile noexcept
__int_type | operator-- (int) noexcept
__int_type | operator-- (int) volatile noexcept
__int_type | operator-= (__int_type __i) noexcept
__int_type | operator-= (__int_type __i) volatile noexcept
__int_type | operator= (__int_type __i) noexcept
__int_type | operator= (__int_type __i) volatile noexcept
__atomic_base & | operator= (const __atomic_base &) volatile=delete
__atomic_base & | operator= (const __atomic_base &)=delete
__int_type | operator^= (__int_type __i) noexcept
__int_type | operator^= (__int_type __i) volatile noexcept
__int_type | operator|= (__int_type __i) noexcept
__int_type | operator|= (__int_type __i) volatile noexcept

## Detailed Description

template<typename _ITp>
struct std::__atomic_base< _ITp >

Base class for atomic integrals.

Definition at line 258 of file atomic_base.h.

## Member Typedef Documentation

## difference_type

template<typename _ITp >

using std::__atomic_base< _ITp >::difference_type = value_type

Definition at line 261 of file atomic_base.h.

## value_type

template<typename _ITp >

using std::__atomic_base< _ITp >::value_type = _ITp

Definition at line 260 of file atomic_base.h.

## Constructor & Destructor Documentation

## __atomic_base()

template<typename _ITp >

constexpr std::__atomic_base< _ITp >::__atomic_base | ( | __int_type | __i | ) |

inline constexpr noexcept

Definition at line 279 of file atomic_base.h.

## Member Function Documentation

## is_lock_free() [1/2]

template<typename _ITp >

bool std::__atomic_base< _ITp >::is_lock_free | ( |  | ) | const

inline noexcept

Definition at line 374 of file atomic_base.h.

## is_lock_free() [2/2]

template<typename _ITp >

bool std::__atomic_base< _ITp >::is_lock_free | ( |  | ) | const volatile

inline noexcept

Definition at line 382 of file atomic_base.h.

## operator __int_type() [1/2]

template<typename _ITp >

std::__atomic_base< _ITp >::operator __int_type | ( |  | ) | const

inline noexcept

Definition at line 281 of file atomic_base.h.

## operator __int_type() [2/2]

template<typename _ITp >

std::__atomic_base< _ITp >::operator __int_type | ( |  | ) | const volatile

inline noexcept

Definition at line 284 of file atomic_base.h.

## operator&=() [1/2]

template<typename _ITp >

__int_type std::__atomic_base< _ITp >::operator&= | ( | __int_type | __i | ) |

inline noexcept

Definition at line 350 of file atomic_base.h.

## operator&=() [2/2]

template<typename _ITp >

__int_type std::__atomic_base< _ITp >::operator&= | ( | __int_type | __i | ) | volatile

inline noexcept

Definition at line 354 of file atomic_base.h.

## operator++() [1/4]

template<typename _ITp >

__int_type std::__atomic_base< _ITp >::operator++ | ( |  | ) |

inline noexcept

Definition at line 318 of file atomic_base.h.

## operator++() [2/4]

template<typename _ITp >

__int_type std::__atomic_base< _ITp >::operator++ | ( |  | ) | volatile

inline noexcept

Definition at line 322 of file atomic_base.h.

## operator++() [3/4]

template<typename _ITp >

__int_type std::__atomic_base< _ITp >::operator++ | ( | int |  | ) |

inline noexcept

Definition at line 302 of file atomic_base.h.

## operator++() [4/4]

template<typename _ITp >

__int_type std::__atomic_base< _ITp >::operator++ | ( | int |  | ) | volatile

inline noexcept

Definition at line 306 of file atomic_base.h.

## operator+=() [1/2]

template<typename _ITp >

__int_type std::__atomic_base< _ITp >::operator+= | ( | __int_type | __i | ) |

inline noexcept

Definition at line 334 of file atomic_base.h.

## operator+=() [2/2]

template<typename _ITp >

__int_type std::__atomic_base< _ITp >::operator+= | ( | __int_type | __i | ) | volatile

inline noexcept

Definition at line 338 of file atomic_base.h.

## operator--() [1/4]

template<typename _ITp >

__int_type std::__atomic_base< _ITp >::operator-- | ( |  | ) |

inline noexcept

Definition at line 326 of file atomic_base.h.

## operator--() [2/4]

template<typename _ITp >

__int_type std::__atomic_base< _ITp >::operator-- | ( |  | ) | volatile

inline noexcept

Definition at line 330 of file atomic_base.h.

## operator--() [3/4]

template<typename _ITp >

__int_type std::__atomic_base< _ITp >::operator-- | ( | int |  | ) |

inline noexcept

Definition at line 310 of file atomic_base.h.

## operator--() [4/4]

template<typename _ITp >

__int_type std::__atomic_base< _ITp >::operator-- | ( | int |  | ) | volatile

inline noexcept

Definition at line 314 of file atomic_base.h.

## operator-=() [1/2]

template<typename _ITp >

__int_type std::__atomic_base< _ITp >::operator-= | ( | __int_type | __i | ) |

inline noexcept

Definition at line 342 of file atomic_base.h.

## operator-=() [2/2]

template<typename _ITp >

__int_type std::__atomic_base< _ITp >::operator-= | ( | __int_type | __i | ) | volatile

inline noexcept

Definition at line 346 of file atomic_base.h.

## operator=() [1/2]

template<typename _ITp >

__int_type std::__atomic_base< _ITp >::operator= | ( | __int_type | __i | ) |

inline noexcept

Definition at line 288 of file atomic_base.h.

## operator=() [2/2]

template<typename _ITp >

__int_type std::__atomic_base< _ITp >::operator= | ( | __int_type | __i | ) | volatile

inline noexcept

Definition at line 295 of file atomic_base.h.

## operator^=() [1/2]

template<typename _ITp >

__int_type std::__atomic_base< _ITp >::operator^= | ( | __int_type | __i | ) |

inline noexcept

Definition at line 366 of file atomic_base.h.

## operator^=() [2/2]

template<typename _ITp >

__int_type std::__atomic_base< _ITp >::operator^= | ( | __int_type | __i | ) | volatile

inline noexcept

Definition at line 370 of file atomic_base.h.

## operator|=() [1/2]

template<typename _ITp >

__int_type std::__atomic_base< _ITp >::operator|= | ( | __int_type | __i | ) |

inline noexcept

Definition at line 358 of file atomic_base.h.

## operator|=() [2/2]

template<typename _ITp >

__int_type std::__atomic_base< _ITp >::operator|= | ( | __int_type | __i | ) | volatile

inline noexcept

Definition at line 362 of file atomic_base.h.

The documentation for this struct was generated from the following file:

- atomic_base.h